
#
# error reporting
#

class ParserError(Exception) :
    pass

def error(msg) :
    raise ParserError(msg)


#
# primitives
#

_input = None
_position = 0

def setInput(s) :
    global _input, _position
    _input = s
    _position = 0

def next() :
    global _position
    if _position >= len(_input) :
        error('unexpected end of input')
    x = _input[_position]
    _position = _position + 1
    return x

def save() :
    return _position

def restore(p) :
    global _position
    _position = p

def remaining() :
    return _input[_position:]
