from parserlib3 import *
from mainloop3 import mainLoop

def isDigit(x) : return (x >= '0') and (x <= '9')
def digitToNum(x) : return ord(x) - ord('0')

def combineDigits(a) :
    return reduce((lambda x, y : x*10+y), a, 0)

def applyOp(a, op, b) :
    if op == '*' : return a * b
    elif op == '+' : return a + b
    elif op == '-' : return a - b
    assert False

def mergeTail(x) :
    return reduce((lambda u, v : applyOp(u, v[0], v[1])), x[1], x[0])

digit = condition(isDigit, modifier=digitToNum)
numeral = oneOrMore(digit, modifier=combineDigits)
expr = lambda : expr2()
parenthesized = sequence([char('('), expr, char(')')], lambda x : x[1])
factor = choice([numeral, parenthesized])
termTail = zeroOrMore(sequence([char('*'), factor]))
term = sequence([factor, termTail], modifier=mergeTail)
plusOrMinus = choice([char('+'), char('-')])
exprTail = zeroOrMore(sequence([plusOrMinus, term]))
expr2 = sequence([term, exprTail], modifier=mergeTail)

mainLoop(expr)
