import sys
from parserlib2 import *

#
# main loop
#

def processLine(line, parser) :
    setInput(line)
    x = parser()
    print x

    unparsed = remaining()
    if len(unparsed) > 0 :
        error('unparsed leftover: ' + unparsed)

def readLine() :
    try :
        return raw_input('> ')
    except EOFError :
        return None

def mainLoop(parser) :
    while True :
        line = readLine()
        if (line == None) or (line == 'quit') :
            print 'Bye!'
            break
        try :
            processLine(line, parser)
        except ParserError, e :
            print e
